/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Inlines/templates for my generic algorithms.

****************************************************************************/

// Default less-than operation.
template < class C >
Bool SortLessThan(const C & a, const C & b) {
	return a < b;
}

// Default count operation.
template < class C >
MType SortCount(C & c) {
	return c.Count();
}

/////////////////////////////////////////////////////////////////////////////
//  Sort the contents of the array.  For now, we will use a slow sort.
template < class C >
void Sort(C & c) {
	MType m, n, u=SortCount(c);
	Bool b=TRUE;

	if (u >= 2) {
		for (m=0; b && m<u; ++m) {
			b = FALSE;
			for (n=0; n<u-m-1; ++n) {
				if (SortLessThan(c[n + 1], c[n])) {
					Swap(c[n], c[n + 1]);
					b = TRUE;
				}
			}
		}
	}
}
