/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	This will be our global include file.

****************************************************************************/

#ifndef ALL_H
	#define ALL_H

	// C includes
	#include <stdio.h>
	#include <stdlib.h>
	#include <math.h>
	#include <setjmp.h>
	#include <malloc.h>
	#include <io.h>
	#include <direct.h>
	#include <string.h>
	#include <stdarg.h>
	#include <ctype.h>

	// C++ includes
	#include <new.h>

	#if defined(WIN32)
		#ifndef WIN32_LEAN_AND_MEAN
			#define WIN32_LEAN_AND_MEAN
		#endif

		// Windows includes
		#include <windows.h>
		#include <ddraw.h>
		#include <mmreg.h>
		#include <dsound.h>

		#pragma warning(disable: 4018 4244 4305 4146 4229)

		#define MESSAGE_PUMP long FAR PASCAL WindowProc(HWND, UINT, WPARAM, LPARAM);
	#elif defined(DOS)
		// DOS includes
		#include <dos.h>
		#include <bios.h>

		// A cheat which hopefully works!
		#define swprintf _usprintf

		#define MESSAGE_PUMP u8 MousePoll(void *);
	#endif

	// Library includes
	#include "switches.h"
	#include "base.h"
	#include "ptr.h"
	#include "map.h"
	#include "sound.h"
	#include "istring.h"
	#include "jmath.h"
	#include "inits.h"
	#include "prim2d.h"
	#include "bitmap.h"
	#include "view.h"
	#include "threads.h"
	#include "mouse.h"
	#include "text.h"
	#include "dir.h"
	#include "kb.h"
	#include "algo.h"
	#include "stopwtch.h"
	#include "bignum.h"
	#include "window.h"

#endif
