/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Okay, we need this for our registration system.

****************************************************************************/

#ifndef BIGNUM_H
	#define BIGNUM_H

	class BigNum {
		public:
			BigNum(u32 u=0);
			BigNum(const IString & i);

			void ConvertToString(IString & i);

			BigNum & operator +=(const BigNum & c);

			BigNum operator +(const BigNum & c) const;
			BigNum operator *(const BigNum & c) const;
			BigNum operator *(const U16 c) const;
			BigNum operator /(const U16 c) const;
			U16 operator %(const U16 c) const;
		protected:
			BigNum QuotientRemainder(U16 & rem, const U16 c) const;
			BigNum ShiftAndAdd(const BigNum & c, MType shift) const;
		private:
			Array < U16 > m_rep;
	};

	#include "bignum.ipp"

#endif
