/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Inlines and template functions for our various bitmaps.

****************************************************************************/

/////////////////////////////////////////////////////////////////////////////
//  Copy a bitmap.
inline Bitmap & Bitmap::operator =(const Bitmap & t) {
	if (t.m_rle) {
		SafeNew(m_rle, 1, __FILE__, __LINE__);
		m_rle->image = t.m_rle->image;
		m_rle->colorData = t.m_rle->colorData;
		m_rle->key = t.m_rle->key;
	}
	Map < Color >::operator =(t);
	return *this;
}

/////////////////////////////////////////////////////////////////////////////
//  Build the RLE data, if it hasn't already been built.
inline void Bitmap::BuildRLE(color key) {
	if (!m_rle || (m_rle->key != key)) {
		MakeRLE(key);
	}
}

/////////////////////////////////////////////////////////////////////////////
//  Initially, bitmaps have no RLEs.
inline Bitmap::Bitmap(void) {
	m_rle = NULL;
}

/////////////////////////////////////////////////////////////////////////////
//  Destroy the bitmap.
inline Bitmap::~Bitmap(void) {
	SafeDelete(m_rle);
}
