/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Platform-independent directory searches.  The leading character specifies
whether the result is a drive, directory, file, or other (not-yet-determined)
type.

****************************************************************************/

#ifndef DIR_H
	#define DIR_H

	enum {
		DIR_FILE			= TEXT_COLOR_WHITE,
		DIR_DRIVE			= TEXT_COLOR_RED,
		DIR_DIRECTORY		= TEXT_COLOR_GREEN,
	};

	typedef u8 DirHandle;

	Bool DirFindAll(List < IString > & dest, const FString & s);
	FString DirGetCurrent(void);
	void DirChange(const FString & dest);
	Array < U8 > DirLoadFile(const FString & filename);
	MType DirFormFilename(char * buf, const FString & s);
	void DirAppend(FString & s, const FString & d);
	FString DirGetAppPath(void);
	Bool DirExists(const FString & d);

	extern char g_appPath[];

#endif
