/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Implementation of initializers.

****************************************************************************/

#include "all.h"

Initializer * Initializer::s_allInitializers;
DeInitializer * DeInitializer::s_allDeInitializers;

/////////////////////////////////////////////////////////////////////////////
//  Construct an initializer.
Initializer::Initializer(void (*f)(void)) {
	m_function = f;
	m_next = s_allInitializers;
	s_allInitializers = this;
}

/////////////////////////////////////////////////////////////////////////////
//  Invoke all of the initialization routines.
void Initializer::InitializeAll(void) {
	Initializer * i;

	for (i=s_allInitializers; i; i=i->m_next) {
		i->m_function();
	}
}

/////////////////////////////////////////////////////////////////////////////
//  Construct an initializer.
DeInitializer::DeInitializer(void (*f)(void)) {
	m_function = f;
	m_next = s_allDeInitializers;
	s_allDeInitializers = this;
}

/////////////////////////////////////////////////////////////////////////////
//  Invoke all of the initialization routines.
void DeInitializer::DeInitializeAll(void) {
	DeInitializer * i;

	for (i=s_allDeInitializers; i; i=i->m_next) {
		i->m_function();
	}
}
