/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	A class for initializers - these are things that build lookup tables,
allocate resources, etc. when the app is first run.  We also have a class for
things that need to be freed when the app is terminated.

****************************************************************************/

#ifndef INITS_H
	#define INITS_H

	class Initializer {
		public:
			Initializer(void (*f)(void));
			static void InitializeAll(void);
		protected:
		private:
			Initializer * m_next;
			void (*m_function)(void);

			static Initializer * s_allInitializers;
	};

	class DeInitializer {
		public:
			DeInitializer(void (*f)(void));
			static void DeInitializeAll(void);
		protected:
		private:
			DeInitializer * m_next;
			void (*m_function)(void);

			static DeInitializer * s_allDeInitializers;
	};

#endif
