/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	The implementation of our keyboard handler.

****************************************************************************/

#include "all.h"

Key g_keyBuffer[256];
U8 g_keyFront, g_keyBack;

/////////////////////////////////////////////////////////////////////////////
//	Pop the most-recently used key from the keyboard queue.
Key KeyPop(void) {
	Key keyMask=0;

	if (GetKeyState(VK_SHIFT) < 0)
		keyMask |= KB_SHIFT;
	if (GetKeyState(VK_CONTROL) < 0)
		keyMask |= KB_CTRL;
	if (GetKeyState(VK_MENU) < 0)
		keyMask |= KB_ALT;
	return g_keyBuffer[g_keyFront++] | keyMask;
}

/////////////////////////////////////////////////////////////////////////////
//  Check if there are any keystrokes available.
Bool KeysThere(void) {
	return g_keyFront != g_keyBack;
}

/////////////////////////////////////////////////////////////////////////////
//  Is the indicated key presently depressed.
Bool KeyDown(Key k) {
	if (k == KB_SHIFT) {
		k = VK_SHIFT;
	} else if (k == KB_CTRL) {
		k = VK_CONTROL;
	} else if (k == KB_ALT) {
		k = VK_MENU;
	}
	if (GetKeyState(k) < 0)
		return TRUE;
	else
		return FALSE;
}
