/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	The implementation of our keyboard handler.

****************************************************************************/

#include "all.h"

Bool g_pressed[256];

/////////////////////////////////////////////////////////////////////////////
//	Pop the most-recently used key from the keyboard queue.
Key KeyPop(void) {
	u16 u = _bios_keybrd(_NKEYBRD_SHIFTSTATUS);
	Key v = _bios_keybrd(_NKEYBRD_READ);

	v = (v >> 8) & 0xff;
	if (u & 3) {
		v |= KB_SHIFT;
	}
	if (u & 4) {
		v |= KB_CTRL;
	}
	if (u & 8) {
		v |= KB_ALT;
	}
	// HEREHEREHERE for now. . .
	if (v == KB_ESC)
		exit(EXIT_SUCCESS);
	return v;
}

/////////////////////////////////////////////////////////////////////////////
//  Check if there are any keystrokes available.
Bool KeysThere(void) {
	return _bios_keybrd(_NKEYBRD_READY);
}

/////////////////////////////////////////////////////////////////////////////
//  Is the indicated key presently depressed.
Bool KeyDown(Key k) {
	// HEREHEREHERE a HACK.  We have to look up the appropriate keyboard
	// polling code.
	memset(g_pressed, 0, sizeof(g_pressed));
	while (KeysThere()) {
		Key l = KeyPop();

		if (l & KB_SHIFT) {
			g_pressed[0xff] = TRUE;
		}
		if (l & KB_CTRL) {
			g_pressed[0xfe] = TRUE;
		}
		if (l & KB_ALT) {
			g_pressed[0xfd] = TRUE;
		}
		g_pressed[l & KB_BASE_MASK] = TRUE;
	}
	if (k == KB_SHIFT) {
		k = 0xff;
	} else if (k == KB_CTRL) {
		k = 0xfe;
	} else if (k == KB_ALT) {
		k = 0xfd;
	}

	// HEREHEREHERE for now. . .
	if (g_pressed[KB_ESC])
		exit(EXIT_SUCCESS);
	return g_pressed[k];
}
