/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Our base class for map-related stuff.

****************************************************************************/

#ifndef MAP_H
	#define MAP_H

	/////////////////////////////////////////////////////////////////////////
	//	For two-dimensional maps.
	template < class O >
	class Map {
		public:
			// Maps may have to tightly regulate reads and writes to them.
			enum {
				READ			= 1,
				WRITE			= 2
			};

			Map(void);
			virtual ~Map(void);
			void Destroy(void);
			void Allocate(MType width, MType height, const char * f, int l);
			MArray < O > operator [](MType ind);
			const MArray < O > operator [](MType ind) const;

			Map & operator =(const Map & m);

			MType GetWidth(void) const;
			MType GetHeight(void) const;

			virtual void Open(u8 option);
			virtual void Close(void);
		protected:
			Array < O * > m_elements;
			MType m_width;
		private:
			#if !defined(NDEBUG)
				Bool m_isOpen;
			#endif
	};

	#include "map.ipp"

#endif
