/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Mouse-related stuff.

****************************************************************************/

#include "all.h"

List < MouseHotspotGroup * > MouseHotspotGroup::s_allGroups;
Bool g_mouseDisplay;

/////////////////////////////////////////////////////////////////////////////
//  Need a virtual destructor for this guy.
MouseHotspot::~MouseHotspot(void) {
}

/////////////////////////////////////////////////////////////////////////////
//  Default action for a mouse hotspot is to ignore mouse clicks.
void MouseHotspot::Click(u16 x, u16 y) {
}

/////////////////////////////////////////////////////////////////////////////
//  Default action for a mouse hotspot is to ignore right-clicks.
void MouseHotspot::RClick(u16 x, u16 y) {
}

/////////////////////////////////////////////////////////////////////////////
//  Add a group of mouse hotspots to the current group.
void MouseHotspotGroup::AddGroup(MouseHotspotGroup * p) {
	s_allGroups += p;
}

/////////////////////////////////////////////////////////////////////////////
//  Remove this group.
void MouseHotspotGroup::RemoveGroup(MouseHotspotGroup * p) {
	s_allGroups -= p;
}

/////////////////////////////////////////////////////////////////////////////
//  Check all of the mouse regions to see if anyone cares about this mouse
// click.
void MouseHotspotGroup::Click(u16 x, u16 y) {
	MType m;

	for (m=0; m<s_allGroups.Count(); ++m) {
		MouseHotspotGroup & g = *s_allGroups[m];
		MType n;

		for (n=0; n<g.Count(); ++n) {
			g[n]->Click(x, y);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
//  Check all of the mouse regions to see if anyone cares about right-
// clicking this guy.
void MouseHotspotGroup::RClick(u16 x, u16 y) {
	MType m;

	for (m=0; m<s_allGroups.Count(); ++m) {
		MouseHotspotGroup & g = *s_allGroups[m];
		MType n;

		for (n=0; n<g.Count(); ++n) {
			g[n]->RClick(x, y);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
//  Indicate whether the mouse is active or not.
void MouseDisplay(Bool offOn) {
	g_mouseDisplay = offOn;
}
