/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	This inlines for the mouse driver.

****************************************************************************/

extern u16 g_mouseX, g_mouseY;
extern Bool g_mouseDisplay;

/////////////////////////////////////////////////////////////////////////
//  Get the mouse X value.
inline u16 MouseGetX(void) {
	return g_mouseX;
}

/////////////////////////////////////////////////////////////////////////
//  Get the mouse Y value.
inline u16 MouseGetY(void) {
	return g_mouseY;
}

/////////////////////////////////////////////////////////////////////////////
//  Return the x coordinate of this mouse hotspot.
inline u16 MouseHotspot::GetX(void) const {
	return m_x;
}

/////////////////////////////////////////////////////////////////////////////
//  Return the y coordinate of this mouse hotspot.
inline u16 MouseHotspot::GetY(void) const {
	return m_y;
}

/////////////////////////////////////////////////////////////////////////////
//  Return the width of this hotspot.
inline u16 MouseHotspot::GetWidth(void) const {
	return m_width;
}

/////////////////////////////////////////////////////////////////////////////
//  Return the height of this hotspot.
inline u16 MouseHotspot::GetHeight(void) const {
	return m_height;
}

/////////////////////////////////////////////////////////////////////////////
//  Set the dimensions of this hotspot.
inline void MouseHotspot::SetDims(u16 x, u16 y, u16 w, u16 h) {
	m_x = x;
	m_y = y;
	m_width = w;
	m_height = h;
}

/////////////////////////////////////////////////////////////////////////////
//  Check if this location lies within my region.
inline Bool MouseHotspot::InRegion(u16 x, u16 y) {
	return ((x >= m_x) && (y >= m_y) && (x < m_x + m_width) && (y < m_y + m_height));
}

/////////////////////////////////////////////////////////////////////////////
//  Is the mouse visible?
inline Bool MouseIsVisible(void) {
	return g_mouseDisplay;
}
