/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	The implementation of our 2D primitives.
	HEREHEREHERE for now, we're going back and forth on whether to use DX or
software.  What we'll eventually have to do is make this all a bunch of
function pointers and install the appropriate ones based on CAPS detection.

****************************************************************************/

#include "all.h"

/////////////////////////////////////////////////////////////////////////////
void DrawLine(View & v,
			  color c,
			  u16 x1,
			  u16 y1,
			  u16 x2,
			  u16 y2) {
	s32 dy = (s32)y2 - (s32)y1;
	s32 dx = (s32)x2 - (s32)x1;
	s32 x, y;

	v.Open(v.WRITE);
	if (Abs(dy) > Abs(dx)) {
		dx = (dx << 16) / dy;
		dy = Sign(dy);
		x = (s32)x1 << 16;
		while (y1 != y2) {
			v[y1][x >> 16] = c;
			x += dx;
			y1 += dy;
		}
		v[y1][x >> 16] = c;
	} else {
		dy = (dy << 16) / dx;
		dx = Sign(dx);
		y = (s32)y1 << 16;
		while (x1 != x2) {
			v[y >> 16][x1] = c;
			x1 += dx;
			y += dy;
		}
		v[y >> 16][x1] = c;
	}
	v.Close();
}
