/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	The implementation of the stopwatches.

****************************************************************************/

#include "all.h"

#if defined(ACTIVATE_STOPWATCH)
	static Real s_lastTime;
	static Real s_frameStart;
	static FILE * s_report;
	static Bool s_enable;

	/////////////////////////////////////////////////////////////////////////////
	//  Start timing here.
	void StopwatchStart(void) {
		if (s_enable) {
			Real curTime = GetCPUSeconds();
	
			if (s_report) {
				fprintf(s_report, "Loop time:  %g\n", curTime - s_lastTime);
				fprintf(s_report, "Total frame time:  %g\n", curTime - s_frameStart);
			} else {
				s_report = fopen("stopwtch.txt", "w");
				fprintf(s_report, "Stopwatch activated.\n");
			}
			s_frameStart = s_lastTime = GetCPUSeconds();
		}
	}

	/////////////////////////////////////////////////////////////////////////////
	//  Mark the current time.
	void StopwatchTick(const char * name) {
		if (s_enable) {
			Real curTime = GetCPUSeconds();
	
			fprintf(s_report, "Until %s:  %g\n", name, curTime - s_lastTime);
			s_lastTime = GetCPUSeconds();
		}
	}

	/////////////////////////////////////////////////////////////////////////////
	//  Enable the stopwatches.
	void StopwatchEnable(void) {
		s_enable = TRUE;
	}
	
#endif
