/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Okay, this will have all of our text management functions.

****************************************************************************/

#ifndef TEXT_H
	#define TEXT_H

	#define TEXT_NUM_TABS		32

	// Text control codes.
	enum {
		TEXT_RESERVED_0,
		TEXT_COLOR_BLACK,
		TEXT_COLOR_RED,
		TEXT_COLOR_GREEN,
		TEXT_COLOR_BLUE,
		TEXT_COLOR_ORANGE,
		TEXT_COLOR_YELLOW,
		TEXT_COLOR_PURPLE,
		TEXT_COLOR_WHITE,
		TEXT_TAB,

		TEXT_CARRIAGE_RETURN,
		TEXT_COLOR_DEFAULT,
		TEXT_BGCOLOR_SPECIFIED,
		TEXT_LINE_FEED,
		TEXT_COLOR_SPECIFIED,
		TEXT_NUM_CONTROL_CODES
	};

	typedef u16 FontHandle;

	FontHandle TextLoadFixedFont(const FString & name,
								 u16 width,
								 u16 height,
								 u16 numberOfCharacters);
	u16 TextGetFontWidth(FontHandle f);
	u16 TextGetFontHeight(FontHandle f);
	void TextWrite(Receptor & v,
				   FontHandle f,
				   u16 x,
				   u16 y,
				   color c,
				   const FString & i,
				   u8 options = Bitmap::COLORIZE);
	void TextSetTab(u8 index, u16 indent);

#endif
