/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Inlines for views.

****************************************************************************/

#if defined(WIN32)
	extern LPDIRECTDRAW7 g_pDD;
	extern LPDIRECTDRAWSURFACE7 g_pDDSPrimary;
	extern LPDIRECTDRAWSURFACE7 g_pDDSBack;
	extern Bool g_bActive;
	extern color g_redShift, g_greenShift, g_blueShift;
	extern u8 g_redMask, g_greenMask, g_blueMask;
	extern u16 g_ddrawWidth, g_ddrawHeight, g_ddrawPitch;
	extern u8 g_ddrawDepth;
#elif defined(DOS)
	extern u16 g_dosWidth, g_dosHeight;
	extern MType g_dosPitch;
	extern u8 g_dosDepth;
#endif

/////////////////////////////////////////////////////////////////////////////
//  What's my depth?
inline MType View::GetDepth(void) const {
	#if defined(WIN32)
		return g_ddrawDepth;
	#elif defined(DOS)
		return g_dosDepth;
	#endif
}

/////////////////////////////////////////////////////////////////////////////
//  If the surface is not locked, lock it (for software use).
inline void View::Open(u8 option) {
	if (!m_locked) {
		OLLock();
		Receptor::Open(option);
	}
}

/////////////////////////////////////////////////////////////////////////////
//  If the surface is locked, unlock it (for hardware use).
inline void View::Close(void) {
	if (m_locked) {
		Receptor::Close();
		OLUnlock();
	}
}

/////////////////////////////////////////////////////////////////////////////
//  Return the pitch - well, not exactly; the pitch divided by sizeof(Color).
inline u16 View::GetPitchInColor(void) const {
	#if defined(WIN32)
		return g_ddrawPitch;
	#elif defined(DOS)
		return g_dosPitch;
	#endif
}
