/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Inlines, etc. for windows.

****************************************************************************/

/////////////////////////////////////////////////////////////////////////////
//  Make a window.
inline Window::Window(void) {
	SetTab(0);
}

/////////////////////////////////////////////////////////////////////////////
//  Get the dimensions of where this panel should be written to.
inline void Window::GetPanelDims(u16 & x, u16 & y, u16 & w, u16 & h) {
	u16 fh = TextGetFontHeight(g_windowFont);

	x = m_x + 2;
	y = m_y + fh;
	w = m_w - 4;
	h = m_h - fh;
}

/////////////////////////////////////////////////////////////////////////////
//  Force the window to be redrawn.
inline void Window::ForceRedraw(void) {
	MakeDirty();
	m_panels[m_selection].redraw->GenerateContent();
}

/////////////////////////////////////////////////////////////////////////////
//  Specify which of my tabs is active.
inline void Window::SetTab(u8 tab) {
	m_selection = tab;
	MakeDirty();
}

/////////////////////////////////////////////////////////////////////////////
//  What is the active tab.
inline u8 Window::GetTab(void) {
	return m_selection;
}

/////////////////////////////////////////////////////////////////////////////
//  The window hotspots need to know what change they effect.
inline void WindowSpot::SetArguments(Window * w, u8 tab) {
	m_window = w;
	m_tab = tab;
}

/////////////////////////////////////////////////////////////////////////////
//  The client hotspots need to know what change they effect.
inline void ClientSpot::SetArguments(Window * w) {
	m_window = w;
}

/////////////////////////////////////////////////////////////////////////////
//  Keep track of who my parent is.
inline void Panel::SetParent(Window * parent) {
	m_parent = parent;
}

/////////////////////////////////////////////////////////////////////////////
//  Instanciate a text panel.
inline TextPanel::TextPanel(void) {
	MakeDirty();
}

/////////////////////////////////////////////////////////////////////////////
//  Specify the X position of this GUI element.
inline void GUIElement::SetX(u16 x) {
	m_x = x;
}

/////////////////////////////////////////////////////////////////////////////
//  Specify the Y position of this GUI element.
inline void GUIElement::SetY(u16 y) {
	m_y = y;
}

/////////////////////////////////////////////////////////////////////////////
//  How many lines in this list of strings.
inline u32 IListTextPanel::Bottom(void) {
	return (u32)m_data.Count();
}
